<template>
  <div>
    <div class="form-group col-6">
      <label 
        class="required"
        style="margin-top: 1em;"
      >
        Format
      </label>
      <p>Sélectionner un format dans la liste</p>
      <ValidationProvider
        v-slot="{ classes, errors }"
        name="Format Href"
        :rules="`${isRequired ? 'required' : ''}`"
      >
        <div
          class="control"
          :class="isRequired ? classes : ''"
        >
          <Multiselect
            v-model="form.format"
            :options="resourceDataFormats"
            track-by="codename"
            label="display_name"
            select-label=""
            selected-label=""
            deselect-label=""
            :searchable="false"
            placeholder="Sélectionner un format"
          />
          <span class="form-errors">{{ errors[0] }}</span>
        </div>
      </ValidationProvider>
    </div>
    <div class="form-row">
      <div
        class="form-group col"
        style="margin: 0 1em 0 -5px;"
      >
        <label 
          class="required"
          style="margin-top: 1em;"
        >
          URL
        </label>
        <p>Entrer l'url de la donnée à référencer.</p>
        <ValidationProvider
          v-slot="{ classes, errors }"
          name="URL"
          :rules="`${isRequired ? 'required' : ''}`"
        >
          <div
            class="control"
            :class="isRequired ? classes : ''"
          >
            <input
              v-model="form.href"
              class="form-control"
              type="text"
              placeholder="https://"
            />
            <span class="form-errors">{{ errors[0] }}</span>
          </div>
        </ValidationProvider>
      </div>
    </div>
  </div>
</template>

<script>
import Multiselect from 'vue-multiselect';

import { mapState, mapActions } from 'vuex';

import { ValidationProvider, extend, configure } from 'vee-validate';
import { required } from 'vee-validate/dist/rules';

extend('required', {
  ...required,
  message: 'Ce champ est requis'
});
configure({
  classes: {
    valid: 'is-valid',
    invalid: 'is-invalid'
  }
});

export default {
  name: 'HrefResourceCreator',

  components: {
    Multiselect,
    ValidationProvider
  },

  props: {
    required: {
      type: Boolean,
      default: true
    }
  },

  data() {
    return {
      isRequired: true,
      form: {
        type: 'href',
        format: null,
        href: null
      }
    };
  },

  computed: {
    ...mapState('resources', [
      'resourceDataFormats',
    ])
  },

  watch: {
    required(newValue) {
      this.isRequired = newValue;
    },
    form: {
      deep: true,
      handler(newValue) {
        if (newValue.format || newValue.href) {
          this.setRequired(true);
        } else {
          this.setRequired(false);
        }
      }
    },
    'form.href': function() {
      this.setResourceURL();
    }
  },

  created() {
    this.isRequired = this.required;
    if (this.resourceDataFormats.length === 0) {
      this.GET_RESOURCE_DATA_FORMATS();
    }
  },

  methods: {
    ...mapActions('resources', [
      'GET_RESOURCE_DATA_FORMATS'
    ]),

    setRequired(e) {
      this.isRequired = e;
      this.$emit('set', {
        required: this.isRequired
      });
    },

    setResourceURL() {
      this.$emit('set', {
        form: this.form,
        required: this.isRequired
      });
    }
  }
}
</script>

<style lang="less" scoped>

</style>
